=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2005-11-16 13:46:41 +0000
+++ bzrlib/delta.py	2006-01-13 07:37:48 +0000
@@ -160,6 +160,20 @@
         files within them.
     """
 
+    old_tree.lock_read()
+    try:
+        new_tree.lock_read()
+        try:
+            return _compare_trees(old_tree, new_tree, want_unchanged,
+                                  specific_files)
+        finally:
+            new_tree.unlock()
+    finally:
+        old_tree.unlock()
+
+
+def _compare_trees(old_tree, new_tree, want_unchanged, specific_files):
+
     from osutils import is_inside_any
     
     old_inv = old_tree.inventory

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-11-11 17:46:11 +0000
+++ bzrlib/diff.py	2006-01-13 07:37:48 +0000
@@ -190,6 +190,21 @@
         If set, use an external GNU diff and pass these options.
     """
 
+    old_tree.lock_read()
+    try:
+        new_tree.lock_read()
+        try:
+            return _show_diff_trees(old_tree, new_tree, to_file,
+                                    specific_files, external_diff_options)
+        finally:
+            new_tree.unlock()
+    finally:
+        old_tree.unlock()
+
+
+def _show_diff_trees(old_tree, new_tree, to_file,
+                     specific_files, external_diff_options):
+
     # TODO: Options to control putting on a prefix or suffix, perhaps as a format string
     old_label = ''
     new_label = ''

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2005-12-19 20:31:01 +0000
+++ bzrlib/tree.py	2006-01-13 07:37:48 +0000
@@ -104,6 +104,12 @@
         """Print file with id `file_id` to stdout."""
         import sys
         sys.stdout.write(self.get_file_text(file_id))
+
+    def lock_read(self):
+        pass
+
+    def unlock(self):
+        pass
         
         
 class RevisionTree(Tree):
@@ -172,6 +178,12 @@
     def kind(self, file_id):
         return self._inventory[file_id].kind
 
+    def lock_read(self):
+        self._branch.lock_read()
+
+    def unlock(self):
+        self._branch.unlock()
+
 
 class EmptyTree(Tree):
     def __init__(self):

